//+------------------------------------------------------------------+
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_width1  2
#property indicator_width4  2
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT
#property indicator_style5  STYLE_DOT
#property indicator_style6  STYLE_DOT

//
//
//
//
//

extern string  TimeFrame             = "Current time frame";
extern int     RsiPeriod             = 14;
extern int     RsiSmoothingFactor    = 5;
extern double  WPFast                = 2.618;
extern double  WPSlow                = 4.236;
extern string  FirstSymbol           = "";
extern string  SecondSymbol          = "GBPUSD";
extern bool    Interpolate           = true;
extern bool    FastSignalVisible     = true;
extern bool    SlowSignalVisible     = true;
extern string  UniqueID              = "QQEDifferentPairs";
extern color   FirstSymbolColor      = DeepSkyBlue;
extern color   FirstSymbolFastColor  = Red;
extern color   SecondSymbolColor     = PaleVioletRed;
extern color   SecondSymbolFastColor = Violet;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer1ss[];
double buffer1sf[];
double buffer2ss[];
double buffer2sf[];

//
//
//
//
//

string indicatorScreenName;
string indicatorFileName;
bool   returnBars;
bool   calculateValues;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   if (FirstSymbol == "" ) FirstSymbol = Symbol();
      SetIndexBuffer(0,buffer1);   SetIndexStyle(0,DRAW_LINE,EMPTY,EMPTY,FirstSymbolColor);
      SetIndexBuffer(1,buffer1ss); SetIndexStyle(1,DRAW_LINE,EMPTY,EMPTY,FirstSymbolColor);
      SetIndexBuffer(2,buffer1sf); SetIndexStyle(2,DRAW_LINE,EMPTY,EMPTY,FirstSymbolFastColor);
      SetIndexBuffer(3,buffer2);   SetIndexStyle(3,DRAW_LINE,EMPTY,EMPTY,SecondSymbolColor);
      SetIndexBuffer(4,buffer2ss); SetIndexStyle(4,DRAW_LINE,EMPTY,EMPTY,SecondSymbolColor);
      SetIndexBuffer(5,buffer2sf); SetIndexStyle(5,DRAW_LINE,EMPTY,EMPTY,SecondSymbolFastColor);

      //
      //
      //
      //
      //
      
      indicatorFileName   = WindowExpertName();
      returnBars          = (TimeFrame=="returnBars");
      calculateValues     = (TimeFrame=="calculateValue");
      timeFrame           = stringToTimeFrame(TimeFrame);
      indicatorScreenName = UniqueID+" "+timeFrameToString(timeFrame)+" RSX ("+RsiPeriod+" ,"+FirstSymbol+","+SecondSymbol+") ";
   IndicatorShortName(indicatorScreenName);
   return(0);
}

//
//
//
//
//

int deinit()
{
   string lookFor       = UniqueID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i = ObjectsTotal() - 1; i >= 0; i--)
   {
      string name = ObjectName(i); if (StringSubstr(name, 0, lookForLength) == lookFor) ObjectDelete(name);
   }
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double emas[][4];
#define iEma 0
#define iEmm 1
#define iEmf 2
#define iEms 3

//
//
//
//
//

int start()
{
   int i,r,y,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { buffer1[0] = limit; return(0); }
           
           //
           //
           //
           //
           //
           
           if (calculateValues)
           {
               if (ArrayRange(emas,0) != Bars) ArrayResize(emas,Bars); 
      
               //
               //
               //
               //
               //
      
               double tr,dv;
               double alpha1 = 2.0/(RsiSmoothingFactor+1.0);
               double alpha2 = 2.0/(RsiPeriod*2.0);
      
               for (i=limit, r=Bars-i-1; i>=0; i--,r++)
               {  
                  buffer1[i]    = buffer1[i+1] + alpha1*(iRSI(NULL,0,RsiPeriod,PRICE_CLOSE,i) - buffer1[i+1]);
                  emas[r][iEma] = emas[r-1][iEma] + alpha2*(MathAbs(buffer1[i+1]-buffer1[i])  - emas[r-1][iEma]);
                  emas[r][iEmm] = emas[r-1][iEmm] + alpha2*(emas[r][iEma]                     - emas[r-1][iEmm]);
                  emas[r][iEmf] = emas[r][iEmm]*WPFast;
                  emas[r][iEms] = emas[r][iEmm]*WPSlow;

                  //
                  //
                  //
                  //
                  //

                  tr = buffer1ss[i+1];
                  dv = tr;
                     if (buffer1[i] < tr) { tr = buffer1[i] + emas[r][iEms]; if ((buffer1[i+1] < dv) && (tr > dv)) tr = dv; }
                     if (buffer1[i] > tr) { tr = buffer1[i] - emas[r][iEms]; if ((buffer1[i+1] > dv) && (tr < dv)) tr = dv; }
                 buffer1ss[i] = tr;
         
                  tr = buffer1sf[i+1];
                  dv = tr;
                     if (buffer1[i] < tr) { tr = buffer1[i] + emas[r][iEmf]; if ((buffer1[i+1] < dv) && (tr > dv)) tr = dv; }
                     if (buffer1[i] > tr) { tr = buffer1[i] - emas[r][iEmf]; if ((buffer1[i+1] > dv) && (tr < dv)) tr = dv; }
                  buffer1sf[i] = tr;
               }
               return(0);
            }
           
           //
           //
           //
           //
           //
           
           if (FirstSymbol  != Symbol() || timeFrame > Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(FirstSymbol ,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
           if (SecondSymbol != Symbol() || timeFrame > Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(SecondSymbol,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
           showSymbol("1",FirstSymbol ,10,FirstSymbolColor);
           showSymbol("2",SecondSymbol,22,SecondSymbolColor);

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      y = iBarShift(FirstSymbol ,timeFrame,Time[i]); 
         buffer1[i]   = iCustom(FirstSymbol ,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,RsiSmoothingFactor,WPFast,WPSlow,0,y);
            if (SlowSignalVisible) buffer1ss[i] = iCustom(FirstSymbol ,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,RsiSmoothingFactor,WPFast,WPSlow,1,y);
            if (FastSignalVisible) buffer1sf[i] = iCustom(FirstSymbol ,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,RsiSmoothingFactor,WPFast,WPSlow,2,y);

      y = iBarShift(SecondSymbol,timeFrame,Time[i]);
         buffer2[i]   = iCustom(SecondSymbol,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,RsiSmoothingFactor,WPFast,WPSlow,0,y);
            if (SlowSignalVisible) buffer2ss[i] = iCustom(SecondSymbol,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,RsiSmoothingFactor,WPFast,WPSlow,1,y);
            if (FastSignalVisible) buffer2sf[i] = iCustom(SecondSymbol,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,RsiSmoothingFactor,WPFast,WPSlow,2,y);
            if (timeFrame <= Period() || !Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //
      
         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               buffer1[i+k]   = buffer1[i]   +(buffer1[i+n]   - buffer1[i]  )*k/n;
               if (SlowSignalVisible) buffer1ss[i+k] = buffer1ss[i] +(buffer1ss[i+n] - buffer1ss[i])*k/n;
               if (FastSignalVisible) buffer1sf[i+k] = buffer1sf[i] +(buffer1sf[i+n] - buffer1sf[i])*k/n;
               buffer2[i+k]   = buffer2[i]   +(buffer2[i+n]   - buffer2[i]  )*k/n;
               if (SlowSignalVisible) buffer2ss[i+k] = buffer2ss[i] +(buffer2ss[i+n] - buffer2ss[i])*k/n;
               if (FastSignalVisible) buffer2sf[i+k] = buffer2sf[i] +(buffer2sf[i+n] - buffer2sf[i])*k/n;
            }               
   }
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void showSymbol(string add, string symbol, int ypos, color theColor)
{
   int window = WindowFind(indicatorScreenName);
   string name;
          name = UniqueID+":"+add;
            ObjectCreate(name,OBJ_LABEL,window,Time[0],0);
               ObjectSet(name, OBJPROP_XDISTANCE, 10);
               ObjectSet(name, OBJPROP_YDISTANCE, ypos);
               ObjectSet(name, OBJPROP_COLOR,theColor);
               ObjectSet(name, OBJPROP_CORNER,1);
               ObjectSetText(name,symbol,9,"Arial bold");
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

int stringToTimeFrame(string tfs)
{
   StringToUpper(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}